Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -7940,9 +7977,9 @@
     mov word [es:di+002h], ax                 ; 26 89 45 02
     test dl, dl                               ; 84 d2
-    je near 05c6dh                            ; 0f 84 97 02
-    mov bx, 00da6h                            ; bb a6 0d
+    je near 05c8ch                            ; 0f 84 97 02
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 eb be
+    call 018e1h                               ; e8 e1 be
     movzx ax, dl                              ; 0f b6 c2
     push ax                                   ; 50
@@ -7951,12 +7988,12 @@
     push 00739h                               ; 68 39 07
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 1a bf
+    call 01922h                               ; e8 10 bf
     add sp, strict byte 0000ah                ; 83 c4 0a
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
     or ah, 00ch                               ; 80 cc 0c
-    jmp near 05ca2h                           ; e9 a1 02
+    jmp near 05cc1h                           ; e9 a1 02
     or ah, 0b2h                               ; 80 cc b2
-    jmp near 05ca2h                           ; e9 9b 02
+    jmp near 05cc1h                           ; e9 9b 02
     mov bx, word [bp+00ah]                    ; 8b 5e 0a
     mov ax, word [bp+004h]                    ; 8b 46 04
@@ -7968,6 +8005,6 @@
     mov word [bp-00eh], ax                    ; 89 46 f2
     cmp ax, strict word 0001ah                ; 3d 1a 00
-    jc near 05c9ah                            ; 0f 82 76 02
-    jc near 05aabh                            ; 0f 82 83 00
+    jc near 05cb9h                            ; 0f 82 76 02
+    jc near 05acah                            ; 0f 82 83 00
     movzx ax, cl                              ; 0f b6 c1
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -8007,5 +8044,5 @@
     ; mov dword [es:di+014h], strict dword 000000000h ; 66 26 c7 45 14 00 00 00 00
     cmp word [bp-00eh], strict byte 0001eh    ; 83 7e f2 1e
-    jc near 05bb7h                            ; 0f 82 04 01
+    jc near 05bd6h                            ; 0f 82 04 01
     mov es, [bp-004h]                         ; 8e 46 fc
     mov word [es:bx], strict word 0001eh      ; 26 c7 07 1e 00
@@ -8033,7 +8070,7 @@
     mov al, byte [es:di+023h]                 ; 26 8a 45 23
     test al, al                               ; 84 c0
-    jne short 05b09h                          ; 75 04
+    jne short 05b28h                          ; 75 04
     xor dx, dx                                ; 31 d2
-    jmp short 05b0ch                          ; eb 03
+    jmp short 05b2bh                          ; eb 03
     mov dx, strict word 00008h                ; ba 08 00
     or dl, 010h                               ; 80 ca 10
@@ -8050,7 +8087,7 @@
     or word [bp-008h], dx                     ; 09 56 f8
     cmp AL, strict byte 003h                  ; 3c 03
-    jne short 05b32h                          ; 75 05
+    jne short 05b51h                          ; 75 05
     mov ax, strict word 00003h                ; b8 03 00
-    jmp short 05b34h                          ; eb 02
+    jmp short 05b53h                          ; eb 02
     xor ax, ax                                ; 31 c0
     or word [bp-008h], ax                     ; 09 46 f8
@@ -8077,19 +8114,19 @@
     xor ch, ch                                ; 30 ed
     mov byte [bp-002h], ch                    ; 88 6e fe
-    jmp short 05b98h                          ; eb 06
+    jmp short 05bb7h                          ; eb 06
     cmp byte [bp-002h], 00fh                  ; 80 7e fe 0f
-    jnc short 05badh                          ; 73 15
+    jnc short 05bcch                          ; 73 15
     movzx dx, byte [bp-002h]                  ; 0f b6 56 fe
     add dx, 00312h                            ; 81 c2 12 03
     mov ax, word [bp-014h]                    ; 8b 46 ec
-    call 01600h                               ; e8 5a ba
+    call 01600h                               ; e8 3b ba
     add ch, al                                ; 00 c5
     inc byte [bp-002h]                        ; fe 46 fe
-    jmp short 05b92h                          ; eb e5
+    jmp short 05bb1h                          ; eb e5
     neg ch                                    ; f6 dd
     mov es, [bp-026h]                         ; 8e 46 da
     mov byte [es:si+001ffh], ch               ; 26 88 ac ff 01
     cmp word [bp-00eh], strict byte 00042h    ; 83 7e f2 42
-    jc near 05c6dh                            ; 0f 82 ae 00
+    jc near 05c8ch                            ; 0f 82 ae 00
     movzx ax, cl                              ; 0f b6 c1
     cwd                                       ; 99
@@ -8109,5 +8146,5 @@
     mov word [es:bx+022h], strict word 00000h ; 26 c7 47 22 00 00
     test al, al                               ; 84 c0
-    jne short 05bffh                          ; 75 09
+    jne short 05c1eh                          ; 75 09
     db  066h, 026h, 0c7h, 047h, 024h, 049h, 053h, 041h, 020h
     ; mov dword [es:bx+024h], strict dword 020415349h ; 66 26 c7 47 24 49 53 41 20
@@ -8118,5 +8155,5 @@
     ; mov dword [es:bx+02ch], strict dword 020202020h ; 66 26 c7 47 2c 20 20 20 20
     test al, al                               ; 84 c0
-    jne short 05c2bh                          ; 75 13
+    jne short 05c4ah                          ; 75 13
     mov word [es:bx+030h], dx                 ; 26 89 57 30
     db  066h, 026h, 0c7h, 047h, 032h, 000h, 000h, 000h, 000h
@@ -8133,15 +8170,15 @@
     xor cl, cl                                ; 30 c9
     mov CH, strict byte 01eh                  ; b5 1e
-    jmp short 05c52h                          ; eb 05
+    jmp short 05c71h                          ; eb 05
     cmp ch, 040h                              ; 80 fd 40
-    jnc short 05c64h                          ; 73 12
+    jnc short 05c83h                          ; 73 12
     movzx dx, ch                              ; 0f b6 d5
     add dx, word [bp+00ah]                    ; 03 56 0a
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 01600h                               ; e8 a2 b9
+    call 01600h                               ; e8 83 b9
     add cl, al                                ; 00 c1
     db  0feh, 0c5h
     ; inc ch                                    ; fe c5
-    jmp short 05c4dh                          ; eb e9
+    jmp short 05c6ch                          ; eb e9
     neg cl                                    ; f6 d9
     mov es, [bp-004h]                         ; 8e 46 fc
@@ -8151,5 +8188,5 @@
     mov dx, strict word 00074h                ; ba 74 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 92 b9
+    call 0160eh                               ; e8 73 b9
     and byte [bp+01ch], 0feh                  ; 80 66 1c fe
     mov sp, bp                                ; 89 ec
@@ -8157,12 +8194,12 @@
     retn                                      ; c3
     cmp ax, strict word 00006h                ; 3d 06 00
-    je short 05c6dh                           ; 74 e4
+    je short 05c8ch                           ; 74 e4
     cmp ax, strict word 00001h                ; 3d 01 00
-    jc short 05c9ah                           ; 72 0c
-    jbe short 05c6dh                          ; 76 dd
+    jc short 05cb9h                           ; 72 0c
+    jbe short 05c8ch                          ; 76 dd
     cmp ax, strict word 00003h                ; 3d 03 00
-    jc short 05c9ah                           ; 72 05
+    jc short 05cb9h                           ; 72 05
     cmp ax, strict word 00004h                ; 3d 04 00
-    jbe short 05c6dh                          ; 76 d3
+    jbe short 05c8ch                          ; 76 d3
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
@@ -8174,11 +8211,11 @@
     mov dx, strict word 00074h                ; ba 74 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 58 b9
+    call 0160eh                               ; e8 39 b9
     or byte [bp+01ch], 001h                   ; 80 4e 1c 01
-    jmp short 05c80h                          ; eb c4
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp short 05c9fh                          ; eb c4
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 05 bc
+    call 018e1h                               ; e8 fb bb
     mov ax, word [bp+016h]                    ; 8b 46 16
     shr ax, 008h                              ; c1 e8 08
@@ -8186,6 +8223,6 @@
     push 007d5h                               ; 68 d5 07
     push 007a7h                               ; 68 a7 07
-    jmp near 05947h                           ; e9 70 fc
-_int14_function:                             ; 0xf5cd7 LB 0x155
+    jmp near 05966h                           ; e9 70 fc
+_int14_function:                             ; 0xf5cf6 LB 0x155
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -8195,5 +8232,5 @@
     add dx, dx                                ; 01 d2
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 35 b9
+    call 0161ch                               ; e8 16 b9
     mov si, ax                                ; 89 c6
     mov bx, ax                                ; 89 c3
@@ -8201,21 +8238,21 @@
     add dx, strict byte 0007ch                ; 83 c2 7c
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 09 b9
+    call 01600h                               ; e8 ea b8
     mov cl, al                                ; 88 c1
     cmp word [bp+00eh], strict byte 00004h    ; 83 7e 0e 04
-    jnc near 05e22h                           ; 0f 83 21 01
+    jnc near 05e41h                           ; 0f 83 21 01
     test si, si                               ; 85 f6
-    jbe near 05e22h                           ; 0f 86 1b 01
+    jbe near 05e41h                           ; 0f 86 1b 01
     mov al, byte [bp+013h]                    ; 8a 46 13
     cmp AL, strict byte 001h                  ; 3c 01
-    jc short 05d1fh                           ; 72 11
-    jbe short 05d73h                          ; 76 63
+    jc short 05d3eh                           ; 72 11
+    jbe short 05d92h                          ; 76 63
     cmp AL, strict byte 003h                  ; 3c 03
-    je near 05e0bh                            ; 0f 84 f5 00
+    je near 05e2ah                            ; 0f 84 f5 00
     cmp AL, strict byte 002h                  ; 3c 02
-    je near 05dc1h                            ; 0f 84 a5 00
-    jmp near 05e1ch                           ; e9 fd 00
+    je near 05de0h                            ; 0f 84 a5 00
+    jmp near 05e3bh                           ; e9 fd 00
     test al, al                               ; 84 c0
-    jne near 05e1ch                           ; 0f 85 f7 00
+    jne near 05e3bh                           ; 0f 85 f7 00
     lea dx, [bx+003h]                         ; 8d 57 03
     in AL, DX                                 ; ec
@@ -8249,5 +8286,5 @@
     ; sub ah, ah                                ; 2a e4
     mov byte [bp+012h], al                    ; 88 46 12
-    jmp near 05dfdh                           ; e9 97 00
+    jmp near 05e1ch                           ; e9 97 00
     mov AL, strict byte 017h                  ; b0 17
     mov dx, bx                                ; 89 da
@@ -8256,8 +8293,8 @@
     mov AL, strict byte 004h                  ; b0 04
     out DX, AL                                ; ee
-    jmp short 05d48h                          ; eb d5
+    jmp short 05d67h                          ; eb d5
     mov dx, strict word 0006ch                ; ba 6c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 a0 b8
+    call 0161ch                               ; e8 81 b8
     mov si, ax                                ; 89 c6
     lea dx, [bx+005h]                         ; 8d 57 05
@@ -8267,18 +8304,18 @@
     and ax, strict word 00060h                ; 25 60 00
     cmp ax, strict word 00060h                ; 3d 60 00
-    je short 05da3h                           ; 74 17
+    je short 05dc2h                           ; 74 17
     test cl, cl                               ; 84 c9
-    je short 05da3h                           ; 74 13
+    je short 05dc2h                           ; 74 13
     mov dx, strict word 0006ch                ; ba 6c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 83 b8
+    call 0161ch                               ; e8 64 b8
     cmp ax, si                                ; 39 f0
-    je short 05d7eh                           ; 74 e1
+    je short 05d9dh                           ; 74 e1
     mov si, ax                                ; 89 c6
     db  0feh, 0c9h
     ; dec cl                                    ; fe c9
-    jmp short 05d7eh                          ; eb db
+    jmp short 05d9dh                          ; eb db
     test cl, cl                               ; 84 c9
-    je short 05dadh                           ; 74 06
+    je short 05dcch                           ; 74 06
     mov al, byte [bp+012h]                    ; 8a 46 12
     mov dx, bx                                ; 89 da
@@ -8290,11 +8327,11 @@
     mov byte [bp+013h], al                    ; 88 46 13
     test cl, cl                               ; 84 c9
-    jne short 05dfdh                          ; 75 43
+    jne short 05e1ch                          ; 75 43
     or AL, strict byte 080h                   ; 0c 80
     mov byte [bp+013h], al                    ; 88 46 13
-    jmp short 05dfdh                          ; eb 3c
+    jmp short 05e1ch                          ; eb 3c
     mov dx, strict word 0006ch                ; ba 6c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 52 b8
+    call 0161ch                               ; e8 33 b8
     mov si, ax                                ; 89 c6
     lea dx, [bx+005h]                         ; 8d 57 05
@@ -8303,18 +8340,18 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 05dedh                          ; 75 17
+    jne short 05e0ch                          ; 75 17
     test cl, cl                               ; 84 c9
-    je short 05dedh                           ; 74 13
+    je short 05e0ch                           ; 74 13
     mov dx, strict word 0006ch                ; ba 6c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 39 b8
+    call 0161ch                               ; e8 1a b8
     cmp ax, si                                ; 39 f0
-    je short 05dcch                           ; 74 e5
+    je short 05debh                           ; 74 e5
     mov si, ax                                ; 89 c6
     db  0feh, 0c9h
     ; dec cl                                    ; fe c9
-    jmp short 05dcch                          ; eb df
+    jmp short 05debh                          ; eb df
     test cl, cl                               ; 84 c9
-    je short 05e03h                           ; 74 12
+    je short 05e22h                           ; 74 12
     mov byte [bp+013h], 000h                  ; c6 46 13 00
     mov dx, bx                                ; 89 da
@@ -8324,10 +8361,10 @@
     mov byte [bp+012h], al                    ; 88 46 12
     and byte [bp+01ch], 0feh                  ; 80 66 1c fe
-    jmp short 05e26h                          ; eb 23
+    jmp short 05e45h                          ; eb 23
     lea dx, [bx+005h]                         ; 8d 57 05
     in AL, DX                                 ; ec
     db  02ah, 0e4h
     ; sub ah, ah                                ; 2a e4
-    jmp short 05dbch                          ; eb b1
+    jmp short 05ddbh                          ; eb b1
     lea dx, [si+005h]                         ; 8d 54 05
     in AL, DX                                 ; ec
@@ -8339,7 +8376,7 @@
     db  02ah, 0e4h
     ; sub ah, ah                                ; 2a e4
-    jmp short 05dfah                          ; eb de
+    jmp short 05e19h                          ; eb de
     or byte [bp+01ch], 001h                   ; 80 4e 1c 01
-    jmp short 05e26h                          ; eb 04
+    jmp short 05e45h                          ; eb 04
     or byte [bp+01ch], 001h                   ; 80 4e 1c 01
     lea sp, [bp-002h]                         ; 8d 66 fe
@@ -8347,5 +8384,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-set_enable_a20_:                             ; 0xf5e2c LB 0x2c
+set_enable_a20_:                             ; 0xf5e4b LB 0x2c
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -8360,8 +8397,8 @@
     mov cl, al                                ; 88 c1
     test bx, bx                               ; 85 db
-    je short 05e45h                           ; 74 05
+    je short 05e64h                           ; 74 05
     or AL, strict byte 002h                   ; 0c 02
     out DX, AL                                ; ee
-    jmp short 05e48h                          ; eb 03
+    jmp short 05e67h                          ; eb 03
     and AL, strict byte 0fdh                  ; 24 fd
     out DX, AL                                ; ee
@@ -8376,5 +8413,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-set_e820_range_:                             ; 0xf5e58 LB 0x8c
+set_e820_range_:                             ; 0xf5e77 LB 0x8c
     push si                                   ; 56
     push bp                                   ; 55
@@ -8405,5 +8442,5 @@
     retn 0000ah                               ; c2 0a 00
     in AL, DX                                 ; ec
-    jmp near 0208bh                           ; e9 d8 c1
+    jmp near 020aah                           ; e9 d8 c1
     sar byte [bx-06f6fh], 089h                ; c0 bf 91 90 89
     mov byte [bx+05283h], al                  ; 88 87 83 52
@@ -8411,25 +8448,26 @@
     inc cx                                    ; 41
     and AL, strict byte 000h                  ; 24 00
-    and word [bp+di+023h], strict byte 0005fh ; 83 63 23 5f
-    db  036h, 05fh
-    ; ss pop di                                 ; 36 5f
-    retf                                      ; cb
+    mov byte [04263h], AL                     ; a2 63 42
     pop di                                    ; 5f
-    rcr word [bx-02ah], 1                     ; d1 5f d6
+    push bp                                   ; 55
     pop di                                    ; 5f
-    fistp dword [bx+07dh]                     ; db 5f 7d
+    jmp far 0f55fh:0f05fh                     ; ea 5f f0 5f f5
+    pop di                                    ; 5f
+    cli                                       ; fa
+    pop di                                    ; 5f
+    pushfw                                    ; 9c
     pushaw                                    ; 60
-    sbb ah, byte [bp+si+040h]                 ; 1a 62 40
+    cmp word [bp+si+05fh], sp                 ; 39 62 5f
     db  062h
-    les bx, [bx-03ch]                         ; c4 5f c4
+    jcxz 05f54h                               ; e3 5f
+    jcxz 05f56h                               ; e3 5f
+    sub AL, strict byte 063h                  ; 2c 63
+    push sp                                   ; 54
+    arpl word [bx+063h], sp                   ; 63 67 63
+    jbe short 05f62h                          ; 76 63
+    db  0eah
     pop di                                    ; 5f
-    or ax, 03563h                             ; 0d 63 35
-    arpl word [bx+si+063h], cx                ; 63 48 63
-    push di                                   ; 57
-    arpl bx, cx                               ; 63 cb
-    pop di                                    ; 5f
-    pop si                                    ; 5e
-    db  063h
-_int15_function:                             ; 0xf5ee4 LB 0x4cd
+    jnl short 05f66h                          ; 7d 63
+_int15_function:                             ; 0xf5f03 LB 0x4cd
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -8441,13 +8479,13 @@
     shr ax, 008h                              ; c1 e8 08
     cmp ax, 000ech                            ; 3d ec 00
-    jnbe near 06383h                          ; 0f 87 8b 04
+    jnbe near 063a2h                          ; 0f 87 8b 04
     push CS                                   ; 0e
     pop ES                                    ; 07
     mov cx, strict word 00012h                ; b9 12 00
-    mov di, 05eafh                            ; bf af 5e
+    mov di, 05eceh                            ; bf ce 5e
     repne scasb                               ; f2 ae
     sal cx, 1                                 ; d1 e1
     mov di, cx                                ; 89 cf
-    mov si, word [cs:di+05ec0h]               ; 2e 8b b5 c0 5e
+    mov si, word [cs:di+05edfh]               ; 2e 8b b5 df 5e
     mov ax, word [bp+012h]                    ; 8b 46 12
     xor ah, ah                                ; 30 e4
@@ -8462,28 +8500,28 @@
     xor ah, ah                                ; 30 e4
     cmp ax, 000c0h                            ; 3d c0 00
-    jne near 06383h                           ; 0f 85 54 04
+    jne near 063a2h                           ; 0f 85 54 04
     or byte [bp+018h], 001h                   ; 80 4e 18 01
-    jmp near 0632ch                           ; e9 f6 03
+    jmp near 0634bh                           ; e9 f6 03
     mov dx, ax                                ; 89 c2
     cmp ax, strict word 00001h                ; 3d 01 00
-    jc short 05f4bh                           ; 72 0e
-    jbe short 05f5fh                          ; 76 20
+    jc short 05f6ah                           ; 72 0e
+    jbe short 05f7eh                          ; 76 20
     cmp ax, strict word 00003h                ; 3d 03 00
-    je short 05f8ch                           ; 74 48
+    je short 05fabh                           ; 74 48
     cmp ax, strict word 00002h                ; 3d 02 00
-    je short 05f6fh                           ; 74 26
-    jmp short 05f99h                          ; eb 4e
+    je short 05f8eh                           ; 74 26
+    jmp short 05fb8h                          ; eb 4e
     test ax, ax                               ; 85 c0
-    jne short 05f99h                          ; 75 4a
+    jne short 05fb8h                          ; 75 4a
     xor ax, ax                                ; 31 c0
-    call 05e2ch                               ; e8 d8 fe
+    call 05e4bh                               ; e8 d8 fe
     and byte [bp+018h], 0feh                  ; 80 66 18 fe
     mov byte [bp+013h], 000h                  ; c6 46 13 00
-    jmp near 05fc4h                           ; e9 65 00
+    jmp near 05fe3h                           ; e9 65 00
     mov ax, strict word 00001h                ; b8 01 00
-    call 05e2ch                               ; e8 c7 fe
+    call 05e4bh                               ; e8 c7 fe
     and byte [bp+018h], 0feh                  ; 80 66 18 fe
     mov byte [bp+013h], dh                    ; 88 76 13
-    jmp near 05fc4h                           ; e9 55 00
+    jmp near 05fe3h                           ; e9 55 00
     mov dx, 00092h                            ; ba 92 00
     in AL, DX                                 ; ec
@@ -8497,13 +8535,13 @@
     and byte [bp+018h], 0feh                  ; 80 66 18 fe
     mov byte [bp+013h], ah                    ; 88 66 13
-    jmp near 05fc4h                           ; e9 38 00
+    jmp near 05fe3h                           ; e9 38 00
     and byte [bp+018h], 0feh                  ; 80 66 18 fe
     mov byte [bp+013h], ah                    ; 88 66 13
     mov word [bp+00ch], ax                    ; 89 46 0c
-    jmp near 05fc4h                           ; e9 2b 00
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp near 05fe3h                           ; e9 2b 00
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 28 b9
+    call 018e1h                               ; e8 1e b9
     mov ax, word [bp+012h]                    ; 8b 46 12
     xor ah, ah                                ; 30 e4
@@ -8511,5 +8549,5 @@
     push 00836h                               ; 68 36 08
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 5b b9
+    call 01922h                               ; e8 51 b9
     add sp, strict byte 00006h                ; 83 c4 06
     or byte [bp+018h], 001h                   ; 80 4e 18 01
@@ -8524,36 +8562,36 @@
     retn                                      ; c3
     mov word [bp+018h], bx                    ; 89 5e 18
-    jmp near 06077h                           ; e9 a6 00
+    jmp near 06096h                           ; e9 a6 00
     mov word [bp+018h], bx                    ; 89 5e 18
-    jmp short 05fc4h                          ; eb ee
+    jmp short 05fe3h                          ; eb ee
     mov word [bp+018h], cx                    ; 89 4e 18
-    jmp short 05fc1h                          ; eb e6
+    jmp short 05fe0h                          ; eb e6
     test byte [bp+012h], 0ffh                 ; f6 46 12 ff
-    je short 0604dh                           ; 74 6c
+    je short 0606ch                           ; 74 6c
     mov dx, 000a0h                            ; ba a0 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 16 b6
+    call 01600h                               ; e8 f7 b5
     test AL, strict byte 001h                 ; a8 01
-    jne near 06323h                           ; 0f 85 33 03
+    jne near 06342h                           ; 0f 85 33 03
     mov bx, strict word 00001h                ; bb 01 00
     mov dx, 000a0h                            ; ba a0 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 12 b6
+    call 0160eh                               ; e8 f3 b5
     mov bx, word [bp+014h]                    ; 8b 5e 14
     mov dx, 00098h                            ; ba 98 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0162ah                               ; e8 22 b6
+    call 0162ah                               ; e8 03 b6
     mov bx, word [bp+00ch]                    ; 8b 5e 0c
     mov dx, 0009ah                            ; ba 9a 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0162ah                               ; e8 16 b6
+    call 0162ah                               ; e8 f7 b5
     mov bx, word [bp+00eh]                    ; 8b 5e 0e
     mov dx, 0009ch                            ; ba 9c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0162ah                               ; e8 0a b6
+    call 0162ah                               ; e8 eb b5
     mov bx, word [bp+010h]                    ; 8b 5e 10
     mov dx, 0009eh                            ; ba 9e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0162ah                               ; e8 fe b5
+    call 0162ah                               ; e8 df b5
     and byte [bp+018h], 0feh                  ; 80 66 18 fe
     mov dx, 000a1h                            ; ba a1 00
@@ -8564,21 +8602,21 @@
     out DX, AL                                ; ee
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 0165ch                               ; e8 1d b6
+    call 0165ch                               ; e8 fe b5
     or AL, strict byte 040h                   ; 0c 40
     movzx dx, al                              ; 0f b6 d0
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 01670h                               ; e8 26 b6
-    jmp near 05fc4h                           ; e9 77 ff
+    call 01679h                               ; e8 10 b6
+    jmp near 05fe3h                           ; e9 77 ff
     cmp ax, strict word 00001h                ; 3d 01 00
-    jne short 0606bh                          ; 75 19
+    jne short 0608ah                          ; 75 19
     xor bx, bx                                ; 31 db
     mov dx, 000a0h                            ; ba a0 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 b1 b5
+    call 0160eh                               ; e8 92 b5
     and byte [bp+018h], 0feh                  ; 80 66 18 fe
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 0165ch                               ; e8 f5 b5
+    call 0165ch                               ; e8 d6 b5
     and AL, strict byte 0bfh                  ; 24 bf
-    jmp short 06041h                          ; eb d6
+    jmp short 06060h                          ; eb d6
     mov word [bp+018h], bx                    ; 89 5e 18
     mov ax, dx                                ; 89 d0
@@ -8588,8 +8626,8 @@
     or dx, ax                                 ; 09 c2
     mov word [bp+012h], dx                    ; 89 56 12
-    jmp near 05fc4h                           ; e9 47 ff
+    jmp near 05fe3h                           ; e9 47 ff
     cli                                       ; fa
     mov ax, strict word 00001h                ; b8 01 00
-    call 05e2ch                               ; e8 a8 fd
+    call 05e4bh                               ; e8 a8 fd
     mov di, ax                                ; 89 c7
     mov ax, word [bp+014h]                    ; 8b 46 14
@@ -8601,5 +8639,5 @@
     mov byte [bp-006h], dl                    ; 88 56 fa
     cmp cx, ax                                ; 39 c1
-    jnc short 060a3h                          ; 73 05
+    jnc short 060c2h                          ; 73 05
     db  0feh, 0c2h
     ; inc dl                                    ; fe c2
